-- Euphoria Assembly Assembler by Jeffrey Fielding (JJProg@cyberbury.net)
include opcodes.e
include instruct.e
include val.e
include get.e
sequence variables, --routines,
labels, infile, outfile, lines, cl, stack, code,
--routinecode, routinelabels
codelabels, codecode
integer ip, line, in, out
in = 0
out = 0
stack = {}
procedure push(object x)
    stack = append(stack,x)
end procedure
function pop()
    object x
    x = stack[length(stack)]
    stack = stack[1..length(stack)-1]
    return x
end function
function removeComments(sequence s)
    integer i
    i = match("--",s)
    if i then
	return s[1..i-1]
    end if
    return s
end function
function removeJunk(sequence s)
    sequence r
    r = {}
    for i = 1 to length(s) do
	if length(s[i]) then
	    r = append(r,s[i])
	end if
    end for
    return r
end function
function splitLine(sequence s)
    sequence r
    integer d, instr
    r = {""}
    d = 0
    instr = 0
    for i = 1 to length(s) do
	if s[i] = ' ' then
	    if instr = 0 then
		r = append(r,"")
	    else
		r[length(r)] &= s[i]
	    end if
	else
	    if s[i] = ',' then
		if d = 0 then
		    r = append(r,"")
		else
		    r[length(r)] &= s[i]
		end if
	    else
		if s[i] = '{' then
		    d += 1
		elsif s[i] = '}' then
		    d -= 1
		elsif s[i] = '"' then
		    instr = not instr
		end if
		r[length(r)] &= s[i]
	    end if
	end if
    end for
    if find('"',s) then
	? r
    end if
    return removeJunk(r)
end function
function getValue(sequence s)
    sequence v
    v = value(s)
    if v[1] != GET_SUCCESS then
	printf(1,infile & ": line %d\nInvalid value format.\n",line)
	puts(1,s)
	if in then
	    close(in)
	end if
	if out then
	    close(out)
	end if
	abort(0)
    end if
    return v[2]
end function
procedure writeOpcode(sequence s)
    integer instruction, opcode, typ, defvar
    object val
    sequence args, argtypes, whichVals
    instruction = 0
    for i = 1 to length(INSTRUCTIONS) do
	if equal(s[1],INSTRUCTIONS[i][1]) then
	    instruction = i
	    exit
	end if
    end for
    if instruction = 0 then
	printf(1,infile & ": line %d\n",line)
	puts(1,"Couldn't find instruction " & s[1] & ".\n")
	if in then
	    close(in)
	end if
	if out then
	    close(out)
	end if
	abort(0)
    end if
    argtypes = {}
    args = {}
    for i = 2 to length(s) do
	typ = 0
	val = 0
	if s[i][1] != '[' then
	    if find(s[i],variables) then
		typ = VAR
		val = find(s[i],variables)
	    --elsif find(s[i],routines) then
		--typ = VAL
		--val = find(s[i],routines)
	    elsif find(s[i],labels[1]) then
		typ = VAL
		val = labels[2][find(s[i],labels[1])]
	    else
		typ = VAL
		val = getValue(s[i])
	    end if
	else
	    if find(s[i][2..length(s[i])-1],variables) then
		typ = VAL
		val = find(s[i][2..length(s[i])-1],variables)
	    --elsif find(s[i][2..length(s[i])-1],routines) then
		--typ = VAL
		--val = find(s[i][2..length(s[i])-1],routines)
	    elsif find(s[i][2..length(s[i])-1],labels[1]) then
		typ = VAL
		val = labels[2][find(s[i][2..length(s[i])-1],labels[1])]
	    else
		if INSTRUCTIONS[instruction][4][i-1] then
		    typ = VAR
		else
		    typ = VAL
		end if
		val = getValue(s[i])
	    end if
	end if
	if typ = VAR and INSTRUCTIONS[instruction][3][i-1] = 0 then
	    typ = VAL
	end if
	args = append(args,val)
	argtypes &= typ
    end for
    instruction = -1
    for i = 1 to length(OPCODES) do
	if equal(OPCODES[i][1],s[1]) and equal(OPCODES[i][3],argtypes) then
	    instruction = OPCODES[i][2]
	    exit
	end if
    end for
    if instruction = -1 then
	printf(1,infile & ": line %d\n",line)
	puts(1,"Couldn't find instruction " & s[1] & " with specified argument types.\n")
	if in then
	    close(in)
	end if
	if out then
	    close(out)
	end if
	abort(0)
    end if
    puts(out,instruction)
    for i = 1 to length(args) do
	WriteValue(out,args[i])
    end for
end procedure
procedure readLines()
    object line
    lines = {}
    line = gets(in)
    while sequence(line) do
	line = removeComments(line[1..length(line)-1])
	lines = append(lines,splitLine(line))
	line = gets(in)
    end while
    lines = removeJunk(lines)
end procedure
function isVariableOk(sequence s)
    if not find(s[1],"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ") then
	return 0
    end if
    for i = 2 to length(s) do
	if not find(s[i],"abcdefghijklmnopqrstuvwxyzABCDEFGHIJKLMNOPQRSTUVWXYZ1234567890_") then
	    return 0
	end if
    end for
    if equal(s[length(s)],"_") then
	return 0
    end if
    return 1
end function
procedure readVariables()
    line = 0
    for i = 1 to length(lines) do
	if find(".variables",lines[i]) then
	    line = i
	end if
    end for
    if line then
	line += 1
	while lines[line][1][1] != '.' do
	    for i = 1 to length(lines[line]) do
		if not isVariableOk(lines[line][i]) then
		    printf(1,infile & ": line %d\n",line)
		    puts(1,"Invalid variable name: " & lines[line][i] & "\n")
		    if in then
			close(in)
		    end if
		    if out then
			close(out)
		    end if
		    abort(0)
		else
		    variables = append(variables,lines[line][i])
		end if
	    end for
	    line += 1
	end while
    end if
end procedure
procedure readFile()
    in = open(infile,"r")
    if in = -1 then
	puts(1,"Can't open " & infile & '\n')
	abort(0)
    end if
    readLines()
    close(in)
end procedure
procedure readRoutine(integer i)
    while i <= length(lines) do
	if lines[i][1][1] = '.' then
	    exit
	end if
	code = append(code,lines[i])
	i += 1
    end while
end procedure
procedure readLabels()
    integer i
    i = 1
    while i <= length(code) do
	if code[i][1][length(code[i][1])] = ':' then
	    labels[1] = append(labels[1],code[i][1][1..length(code[i][1])-1])
	    labels[2] = append(labels[2],i)
	    if length(code[i]) = 1 then
		code = code[1..i-1] & code[i+1..length(code)]
	    else
		code[i] = code[i][2..length(code[i])]
		i += 1
	    end if
	else
	    i += 1
	end if
    end while
end procedure
procedure readRoutines()
    for i = 1 to length(lines) do
	--if equal(lines[i][1],".routine") then
	    --labels = {{},{}}
	    --code = {}
	    --routines = append(routines,lines[i][2])
	    --readRoutine(i+1)
	    --readLabels()
	    --routinecode = append(routinecode,{code,labels})
	--elsif equal(lines[i][1],".code") then
	if equal(lines[i][1],".code") then
	    labels = codelabels
	    code = codecode
	    readRoutine(i+1)
	    readLabels()
	    codecode = code
	    codelabels = labels
	end if
    end for
end procedure
procedure readIncludes()
    for i = 1 to length(lines) do
	if equal(lines[i][1],".include") then
	    push(infile)
	    push(lines)
	    infile = lines[i][2]
	    readFile()
	    readVariables()
	    readIncludes()
	    readRoutines()
	    lines = pop()
	    infile = pop()
	end if
    end for
end procedure
procedure WriteRoutine()
    for i = 1 to length(code) do
	writeOpcode(code[i])
    end for
end procedure
codecode = {}
codelabels = {{},{}}
variables = {}
--routines = {}
--routinecode = {}
cl = command_line()
infile = cl[3] --"t.esm" -- cl[3]
outfile = cl[4] --"t.bin" --cl[4]
readFile()
in = 0
readVariables()
readRoutines()
readIncludes()
out = open(outfile,"wb")
WriteValue(out,length(variables))
--WriteValue(out,length(routines))
--for i = 1 to length(routinecode) do
    --WriteValue(out,length(routinecode[i][1]))
    --code = routinecode[i][1]
    --labels = routinecode[i][2]
    --WriteRoutine()
--end for
code = codecode
labels = codelabels
WriteValue(out,length(code))
WriteRoutine()
close(out)
--for i = 1 to length(routinecode) do
    --puts(1,routines[i] & ":\n")
    --for j = 1 to length(routinecode[i][1]) do
	--for k = 1 to length(routinecode[i][1][j]) do
	    --puts(1,routinecode[i][1][j][k] & ' ')
	--end for
	--puts(1,'\n')
    --end for
--end for
